



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android Launcher分析和修改4——初始化加载数据</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android Launcher分析和修改4——初始化加载数据</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 21:10:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>上面一篇文章说了Launcher是如何被启动的，Launcher启动的过程主要是加载界面数据然后显示出来，</p>
<p>界面数据都是系统APP有关的数据，都是从Launcher的数据库读取，下面我们详细分析Launcher如何加载数据。</p>
<p>在Launcher.java的onCreate()方法里面，调用了开始加载数据接口：</p>
<div>
<pre class="prettyprint linenums"><strong>//Edited by mythou</strong><br /><strong>//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong><br />//加载启动数据<br />
if (!mRestoring) <br />{<br />
    mModel.startLoader(this, true);<br />
}</pre>
</div>
<p>mModel是LauncherModel的对象，由此可见，数据加载主要是在LauncherModel类里面实现的。</p>
<p><strong>1、Callbacks接口</strong></p>
<p>LauncherModel里面，需要先分析一个Callbacks接口。</p>
<div>
<pre class="prettyprint linenums"></pre>
<pre class="prettyprint linenums"><strong>//Edited by mythou<br />//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong></pre>
<pre class="prettyprint linenums"> public interface Callbacks {<br />
        public boolean setLoadOnResume();<br />
        public int getCurrentWorkspaceScreen();<br />
        public void startBinding();<br />
        public void bindItems(ArrayList&lt;ItemInfo&gt; shortcuts, int start, int end);<br />
        public void bindFolders(HashMap&lt;Long,FolderInfo&gt; folders);<br />
        public void finishBindingItems();<br />
        public void bindAppWidget(LauncherAppWidgetInfo info);<br />
        public void bindAllApplications(ArrayList&lt;ApplicationInfo&gt; apps);<br />
        public void bindAppsAdded(ArrayList&lt;ApplicationInfo&gt; apps);<br />
        public void bindAppsUpdated(ArrayList&lt;ApplicationInfo&gt; apps);<br />
        public void bindAppsRemoved(ArrayList&lt;ApplicationInfo&gt; apps, boolean permanent);<br />
        public void bindPackagesUpdated();<br />
        public boolean isAllAppsVisible();<br />
        public void bindSearchablesChanged();<br />
    }</pre>
</div>
<p>Callbacks接口提供了很多接口，用于返回相关的数据给Launcher模块，下面我们对每个接口作用做个阐释。</p>
<p><strong>setLoadOnResume()&nbsp;：</strong>当Launcher.java类的Activity处于onPause的时候，如果重新恢复，需要调用onResume，此时需要在onResume调用这个接口，恢复Launcher数据。</p>
<p><strong>getCurrentWorkspace()：</strong>获取屏幕序号（0~4）</p>
<p><strong>startBinding()：</strong>通知Launcher开始加载数据。清空容器数据，重新加载</p>
<p><strong>bindItems(ArrayList&lt;ItemInfo&gt; shortcuts, int start, int end)：</strong>加载App shortcut、Live Folder、widget到Launcher相关容器。</p>
<p><strong>bindFolders(HashMap&lt;Long, FolderInfo&gt; folders)：</strong>加载folder的内容</p>
<p><strong>finishBindingItems()：</strong>数据加载完成。</p>
<p><strong>bindAppWidget(LauncherAppWidgetInfo item)</strong>：workspace加载APP 快捷方式</p>
<p><strong>bindAllApplications(final ArrayList&lt;ApplicationInfo&gt; apps)：</strong>所有应用列表接着APP图标数据</p>
<p><strong>bindAppsAdded(ArrayList&lt;ApplicationInfo&gt; apps)：</strong>通知Launcher新安装了一个APP，更新数据。</p>
<p><strong>bindAppsUpdated(ArrayList&lt;ApplicationInfo&gt; apps)：</strong>通知Launcher一个APP更新了。（覆盖安装）</p>
<p><strong>bindAppsRemoved(ArrayList&lt;ApplicationInfo&gt; apps, boolean permanent)：</strong>通知Launcher，应用被删除</p>
<p><strong>bindPackagesUpdated()</strong>：多个应用更新。</p>
<p><strong>isAllAppsVisible()：</strong>返回所有应用列表是否可见状态。</p>
<p><strong>bindSearchablesChanged()：</strong>Google搜索栏或者删除区域发生变化时通知Launcher</p>
<p><strong>2、数据加载流程</strong></p>
<p>Launcher.java类继承了Callbacks接口，并实现了该接口。LauncherModel里面会调用这些接口，反馈数据和状态给Launcher。数据加载总体分为两部分，一部分是加载workspace的数据，另一部分是加载All APP界面的数据。</p>
<p>下面是一个加载数据流程图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/109505/201307/10225030-108c19967810451e9c456b5a9fceb86e.jpg" /></p>
<p><strong>3、startLoader()</strong></p>
<p>下面我们先分析startLoader()接口，startLoader主要是启动了一个线程，用于加载数据。</p>
<div>
<pre class="prettyprint linenums"><strong>//Edited by mythou</strong><br /><strong>//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a>  </strong> <br /> public void startLoader(Context context, boolean isLaunching) {<br />
        synchronized (mLock)<br />
        {<br />
            //...............<br />
            if (mCallbacks != null &amp;&amp; mCallbacks.get() != null) {<br />
                isLaunching = isLaunching || stopLoaderLocked();<br />
                mLoaderTask = new LoaderTask(context, isLaunching);<br />
                sWorkerThread.setPriority(Thread.NORM_PRIORITY);<br />
                sWorker.post(mLoaderTask);<br />
            }<br />
        }<br />
    }</pre>
</div>
<p>startLoader主要是启动LoaderTask线程里面的run方法。sWorker是一个Handle对象，用于启动线程的run方法。</p>
<p><strong>&nbsp;4、LoaderTask的run()方法</strong></p>
<div>
<pre class="prettyprint linenums"><strong>//Edited by mythou</strong><br /><strong>//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong><br />  public void run() {<br />
　　　　　　<strong>　//............</strong>

            keep_running: {<br />　　　　　　　　　<strong>//...............</strong>

<strong>　　　　　　　　 //加载当前页面的数据，先把一页的数据加载完成，</strong><br /><strong>                //主要是为了增加程序流畅性，提高用户体验<br />
                </strong>if (loadWorkspaceFirst) {<br />
                    if (DEBUG_LOADERS) Log.d(TAG, "step 1: loading workspace");<br />
                    loadAndBindWorkspace();<br />
                } else {<br />
                    if (DEBUG_LOADERS) Log.d(TAG, "step 1: special: loading all apps");<br />
                    loadAndBindAllApps();<br />
                }

                if (mStopped) {<br />
                    break keep_running;<br />
                }

                <strong>// THREAD_PRIORITY_BACKGROUND设置线程优先级为后台，<br />　　　　　　　　　//这样当多个线程并发后很多无关紧要的线程分配的CPU时间将会减少，有利于主线程的处理</strong><br />
                synchronized (mLock) {<br />
                    if (mIsLaunching) {<br />
                        if (DEBUG_LOADERS) Log.d(TAG, "Setting thread priority to BACKGROUND");<br />
                        android.os.Process.setThreadPriority(Process.THREAD_PRIORITY_BACKGROUND);<br />
                    }<br />
                }<br />　　　　　　　　　<strong>//等待线程空闲的时候，继续加载其他页面数据</strong><br />
                waitForIdle();

                <strong>//加载剩余页面的数据，包含workspace和all app页面</strong><br />
                if (loadWorkspaceFirst) {<br />
                    if (DEBUG_LOADERS) Log.d(TAG, "step 2: loading all apps");<br />
                    loadAndBindAllApps();<br />
                } else {<br />
                    if (DEBUG_LOADERS) Log.d(TAG, "step 2: special: loading workspace");<br />
                    loadAndBindWorkspace();<br />
                }

                // Restore the default thread priority after we are done loading items<br />
                synchronized (mLock) {<br />
                    android.os.Process.setThreadPriority(Process.THREAD_PRIORITY_DEFAULT);<br />
                }<br />
            }<br />
        }</pre>
</div>
<p>上面是经过简化的LoaderTask的run方法代码，其实主要就两部分操作，第一部分操作，加载当前页面的数据</p>
<p>（当前workspace页面或者当前All APP页面的数据）然后等待线程空闲的时候，再加载剩余的页面数据。</p>
<p>代码上面加了关键注释，可以结合代码分析。这样做主要目的是增加Launcher启动的速度，让用户觉得系统初始化速度</p>
<p>较快，有较好的用户体验。先把用户看见的界面初始化完毕，然后再开一个后台线程慢慢加载其他的数据。</p>
<p>下面我们分别分析workspace和All APP加载和绑定。</p>
<p><strong>5、workspace加载数据</strong></p>
<pre class="prettyprint linenums">loadAndBindWorkspace（）方法主要就是执行loadWorkspace()和 bindWorkspace()方法。<br />下面分别对这两个方法进行分析。</pre>
<div>
<pre class="prettyprint linenums">//Edited by mythou<br />//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a>     <br />   private void loadWorkspace() {<br />
　　　　　　　<strong>//..........

</strong>　　　　　　　<strong>//清空容器，存放界面不同的元素，App快捷方式、widget、folder</strong><br />
            synchronized (sBgLock) {<br />
                sBgWorkspaceItems.clear();<br />
                sBgAppWidgets.clear();<br />
                sBgFolders.clear();<br />
                sBgItemsIdMap.clear();<br />
                sBgDbIconCache.clear();

                final ArrayList&lt;Long&gt; itemsToRemove = new ArrayList&lt;Long&gt;();

                final Cursor c = contentResolver.query(<br />
                        LauncherSettings.Favorites.CONTENT_URI, null, null, null, null);

                // +1 for the hotseat (it can be larger than the workspace)<br />
                // Load workspace in reverse order to ensure that latest items are loaded first (and<br />
                // before any earlier duplicates)<br />　　　　　　　　　<strong>　//表示屏幕上的位置，</strong><br /><strong>　　　　　　　　　//第一维表示分屏的序号，其中最后一个代表Hotseat&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong><br /><strong>　　　　　　　　　//第二维表示x方向方格的序号&nbsp;&nbsp;&nbsp; &nbsp; &nbsp; &nbsp;</strong><br /><strong>　　　　　　　　　//第三维表示y方向方格的序号</strong></pre>
<pre class="prettyprint linenums">                final ItemInfo occupied[][][] =<br />
                        new ItemInfo[Launcher.SCREEN_COUNT + ][mCellCountX + ][mCellCountY + ];<br />
　　　　　　　　　<strong> //读取数据库响应键值列序号<br />
                </strong>try {<br />
                    final int idIndex = c.getColumnIndexOrThrow(LauncherSettings.Favorites._ID);<br />
                    final int intentIndex = c.getColumnIndexOrThrow<br />
                            (LauncherSettings.Favorites.INTENT);<br />
                    final int titleIndex = c.getColumnIndexOrThrow<br />
                            (LauncherSettings.Favorites.TITLE);<br />
                    final int iconTypeIndex = c.getColumnIndexOrThrow(<br />
                            LauncherSettings.Favorites.ICON_TYPE);<br />　　　　　　　　　　　 <strong>//...........</strong><br />   　　　　　　　　　　while (!mStopped &amp;&amp; c.moveToNext()) {<br />
                        try {<br />
                            int itemType = c.getInt(itemTypeIndex);

                            switch (itemType) {<br /><strong>　　　　　　　　　　　　　　　　</strong><strong>&nbsp;//item类型为ITEM_TYPE_APPLICATION或者ITEM_TYPE_SHORTCUT&nbsp;&nbsp;</strong><br /><strong>　　　　　　　　　　　　　　　　//container为CONTAINER_DESKTOP或者CONTAINER_HOTSEAT</strong><br /><strong>　　　　　　　　　　　　　　　　//把当前的item添加到sWorkspaceItems中</strong></pre>
<pre class="prettyprint linenums">　　　　　　　　　　　　　　　　case LauncherSettings.Favorites.ITEM_TYPE_APPLICATION:<br />
                            case LauncherSettings.Favorites.ITEM_TYPE_SHORTCUT:<br />
　　　　　　　　　　　　　　　　　　　　　　emType == LauncherSettings.Favorites.ITEM_TYPE_APPLICATION) {<br />
                                    info = getShortcutInfo(manager, intent, context, c, iconIndex,<br />
                                            titleIndex, mLabelCache);<br />
                                } else {<br />
                                    info = getShortcutInfo(c, context, iconTypeIndex,<br />
                                            iconPackageIndex, iconResourceIndex, iconIndex,<br />
                                            titleIndex);<br />
　　　　　　　　　　　　　　　　　　　　<br />
                                    switch (container) {<br />
                                    case LauncherSettings.Favorites.CONTAINER_DESKTOP:<br />
                                    case LauncherSettings.Favorites.CONTAINER_HOTSEAT:<br />　　　　　　　　　　　　　　　　　　　　　<strong>　　 //添加数据</strong><br />
                                        sBgWorkspaceItems.add(info);<br />
                                        break;<br />
                                    default:<br />
                                        <strong>//如果item的属性是folder，添加到folder，创建forder</strong><br />
                                        FolderInfo folderInfo =<br />
                                                findOrMakeFolder(sBgFolders, container);<br />
                                        folderInfo.add(info);<br />
                                        break;<br />
                                    }<br />
                                    sBgItemsIdMap.put(info.id, info);

                                } else {<br />
                                }<br />
                                break;<br />
　　　　　　　　　　　　　　　<strong>　//item类型为文件夹，添加<br />
                            </strong>case LauncherSettings.Favorites.ITEM_TYPE_FOLDER:<br />
                                id = c.getLong(idIndex);<br />
                                FolderInfo folderInfo = findOrMakeFolder(sBgFolders, id);<br />　　　　　　　　　　　　　　　　　　<strong> //.........</strong><br />
                                sBgItemsIdMap.put(folderInfo.id, folderInfo);<br />
                                sBgFolders.put(folderInfo.id, folderInfo);<br />
                                break;<br />
　　　　　　　　　　　　　　　　 <strong>//Widget添加<br />
                            </strong>case LauncherSettings.Favorites.ITEM_TYPE_APPWIDGET:<br />
                                // Read all Launcher-specific widget details<br />
                                int appWidgetId = c.getInt(appWidgetIdIndex);<br />
                                id = c.getLong(idIndex);<br />
　　　　　　　　　　　　　　　　　　　//...........<br />
                                sBgItemsIdMap.put(appWidgetInfo.id, appWidgetInfo);<br />
                                sBgAppWidgets.add(appWidgetInfo);<br />
                                break;<br />
                            }<br />
                        } catch (Exception e) {<br />
                            Log.w(TAG, "Desktop items loading interrupted:", e);<br />
                        }<br />
                    }<br />
                } finally {<br />
                    c.close();<br />
                }<br />
            }<br />
        }</pre>
</div>
<p>workspace的数据加载总的来说也是按照元素属性来区分加载，分为App快捷方式、Widget、Folder元素。</p>
<p>这几个元素分别加载到不同的容器里面。其中sItemsIdMap保存所有元素的id和ItemInfo组成的映射。其他</p>
<p>元素分别加载到3个不同的容器里面，用于后面绑定数据用。这里只给出了loadWorkspace的流程代码，详细代码，</p>
<p>需要看源码，还有很多细节。不过刚开始分析Launcher，我的原则是先把握整体流程和知道改动代码，需要在哪里查找。</p>
<p><strong>6、workspace绑定数据</strong></p>
<p>Launcher的内容绑定分为五步：分别对应着startBinding()、bindItems()、bindFolders()、&nbsp;bindAppWidgets()、</p>
<p>finishBindingItems()的调用。下面针对bindWorkspace做个简单的流程分析。</p>
<div>
<pre class="prettyprint linenums"><strong><br />//Edited by mythou<br />//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong> <br />private void bindWorkspace() {

　　　　　　 <strong>//通知Launcher开始绑定数据</strong><br />
            mHandler.post(new Runnable() {<br />
                public void run() {<br />
                    Callbacks callbacks = tryGetCallbacks(oldCallbacks);<br />
                    if (callbacks != null) {<br />
                        <strong>//绑定数据到launcher,Launcher回调，清空相关容器 OWL</strong><br />
                        callbacks.startBinding();<br />
                    }<br />
                }<br />
            });<strong><br />
            //添加元素到workspace，主要是添加APP快捷方式</strong><br />
            N = workspaceItems.size();<br />
            for (int i=; i&lt;N; i+=ITEMS_CHUNK) {<br />
                final int start = i;<br />
                final int chunkSize = (i+ITEMS_CHUNK &lt;= N) ? ITEMS_CHUNK : (N-i);<br />
                mHandler.post(new Runnable() {<br />
                    public void run() {<br />
                        Callbacks callbacks = tryGetCallbacks(oldCallbacks);<br />
                        if (callbacks != null) {<br />
                            callbacks.bindItems(workspaceItems, start, start+chunkSize);<br />
                        }<br />
                    }<br />
                });<br />
            }<br />
            <strong>//文件夹绑定</strong><br />
            final HashMap&lt;Long, FolderInfo&gt; folders = new HashMap&lt;Long, FolderInfo&gt;(sFolders);<br />
            mHandler.post(new Runnable() {<br />
                public void run() {<br />
                    Callbacks callbacks = tryGetCallbacks(oldCallbacks);<br />
                    if (callbacks != null) {<br />
                        callbacks.bindFolders(folders);<br />
                    }<br />
                }<br />
            });<br />
<strong>            //分两次加载widget ，当前界面和其他界面，增强用户体验OWL</strong><br /><strong>　　　　     //其他页面widget会在后台线程再次加载</strong><br />
            final int currentScreen = oldCallbacks.getCurrentWorkspaceScreen();<br />
            N = sAppWidgets.size();<br />
            // once for the current screen<br />
            for (int i=; i&lt;N; i++) {<br />
                final LauncherAppWidgetInfo widget = sAppWidgets.get(i);<br />
                if (widget.screen == currentScreen) {<br />
                    mHandler.post(new Runnable() {<br />
                        public void run() {<br />
                            Callbacks callbacks = tryGetCallbacks(oldCallbacks);<br />
                            if (callbacks != null) {<br />
                                callbacks.bindAppWidget(widget);<br />
                            }<br />
                        }<br />
                    });<br />
                }<br />
            }<br />
            <strong>//加载其他看不见的屏幕widget</strong><br />
            for (int i=; i&lt;N; i++) {<br />
                final LauncherAppWidgetInfo widget = sAppWidgets.get(i);<br />
                if (widget.screen != currentScreen) {<br />
                    mHandler.post(new Runnable() {<br />
                        public void run() {<br />
                            Callbacks callbacks = tryGetCallbacks(oldCallbacks);<br />
                            if (callbacks != null) {<br />
                                callbacks.bindAppWidget(widget);<br />
                            }<br />
                        }<br />
                    });<br />
                }<br />
            }<br />
            <strong>//加载完成，通知Launcher，已经完成数据加载</strong><br />
            mHandler.post(new Runnable() {<br />
                public void run() {<br />
                    Callbacks callbacks = tryGetCallbacks(oldCallbacks);<br />
                    if (callbacks != null) {<br />
                        callbacks.finishBindingItems();<br />
                    }<br />
                }<br />
            });<br />
        }</pre>
</div>
<p>上面就是Launcher的workspace绑定数据的过程，跟加载数据过程很相似，也是区分3中类型的元素进行加载。</p>
<p>下面我们总结一下，workspace的加载和绑定数据的过程。我们现在回头看，可以发现，其实workspace里面就是</p>
<p>存放了3中数据ItemInfo、FolderInfo、LauncherAppWidgetInfo。分别对应我们的APP快捷方式、文件夹、Widget</p>
<p>数据。其中FolderInfo、LauncherAppWidgetInfo都是继承了ItemInfo。数据加载过程，就是从Launcher的数据库</p>
<p>读取数据然后按元素属性分别放到3个ArrayList里面。绑定数据过程就是把3个ArrayList的队列关联到Launcher界面里面。</p>
<p><strong>&nbsp;7、ALL APP数据加载绑定</strong></p>
<div>
<pre class="prettyprint linenums"><strong><br />//Edited by mythou<br />//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong>    <br />  private void loadAllAppsByBatch() {<strong>//只有这两个标记才需要显示在所有程序列表 OWL</strong><br />
            final Intent mainIntent = new Intent(Intent.ACTION_MAIN, null);<br />
            mainIntent.addCategory(Intent.CATEGORY_LAUNCHER);

            final PackageManager packageManager = mContext.getPackageManager();<br />
            List&lt;ResolveInfo&gt; apps = null;

            int N = Integer.MAX_VALUE;

            int startIndex;<br />
            int i=;<br />
            int batchSize = -;<br />
            while (i &lt; N &amp;&amp; !mStopped) {<br />
                if (i == ) {<br />
                    mAllAppsList.clear();<br />
                    final long qiaTime = DEBUG_LOADERS ? SystemClock.uptimeMillis() : ;<br />
                    <strong>//过滤需要显示的app</strong><br />
                    apps = packageManager.queryIntentActivities(mainIntent, );<br />
                    if (DEBUG_LOADERS) {<br />
                        Log.d(TAG, "queryIntentActivities took "<br />
                                + (SystemClock.uptimeMillis()-qiaTime) + "ms");<br />
                    }<br />
                    if (apps == null) {<br />
                        return;<br />
                    }<br />
                    N = apps.size();<br />
                    if (DEBUG_LOADERS) {<br />
                        Log.d(TAG, "queryIntentActivities got " + N + " apps");<br />
                    }<br />
                    if (N == ) {<br />
                        // There are no apps?!?<br />
                        return;<br />
                    }<br />
                    <strong>//</strong><strong>mBatchSize==0表示一次性加载所有的应用 </strong><br />
                    if (mBatchSize == ) {<br />
                        batchSize = N;<br />
                    } else {<br />
                        batchSize = mBatchSize;<br />
                    }<br />
                }

                final boolean first = i &lt;= batchSize;<br />
                final Callbacks callbacks = tryGetCallbacks(oldCallbacks);<br />
                final ArrayList&lt;ApplicationInfo&gt; added = mAllAppsList.added;<br />
                mAllAppsList.added = new ArrayList&lt;ApplicationInfo&gt;();<br />
　　　　　　　　<strong>　//绑定加载所有的APP数据</strong><br />
                mHandler.post(new Runnable() {<br />
                    public void run() {<br />
                        final long t = SystemClock.uptimeMillis();<br />
                        if (callbacks != null) {<br />
                            if (first) {<br />
                                <strong>//一次性加载所以app，返回数据到launcher</strong><br />
                                callbacks.bindAllApplications(added);<br />
                            } else {<br />
                                callbacks.bindAppsAdded(added);<br />
                            }<br />
                            if (DEBUG_LOADERS) {<br />
                                Log.d(TAG, "bound " + added.size() + " apps in "<br />
                                    + (SystemClock.uptimeMillis() - t) + "ms");<br />
                            }<br />
                        } else {<br />
                            Log.i(TAG, "not binding apps: no Launcher activity");<br />
                        }<br />
                    }<br />
                });<br />
}</pre>
</div>
<p>AllAPP的数据加载和绑定跟workspace的差不多，也是先加载数据然后绑定数据，通知Launcher。加载数据的时候</p>
<p>从PackageManager获取所有已经安装的APK包信息，然后过滤只包含需要显示在所有应用列表的应用，需要包含</p>
<p>ACTION_MAIN和CATEGORY_LAUNCHER两个属性。这个我们在编写应用程序的时候都应该知道。</p>
<p>AllAPP加载跟workspace不同的地方是加载的同时，完成数据绑定的操作，也就是说第一次加载AllAPP页面的数据，</p>
<p>会同时绑定数据到Launcher。第二次需要加载的时候，只会把数据直接绑定到Launcher，而不会重新搜索加载数据。</p>
<p>Launcher启动加载和绑定数据就是这样完成。绑定完数据，Launcher就可以运行。</p>
<p><strong>系列文章：</strong></p>
<h2><strong><a href="http://www.cnblogs.com/mythou/p/3153880.html" rel="external nofollow noreferrer">Android Launcher分析和修改1&mdash;&mdash;Launcher默认界面配置（default_workspace）</a></strong></h2>
<h2><a href="http://www.cnblogs.com/mythou/p/3155692.html" rel="external nofollow noreferrer">Android Launcher分析和修改2&mdash;&mdash;Icon修改、界面布局调整、壁纸设置</a></h2>
<h2><a href="http://www.cnblogs.com/mythou/p/3157452.html" rel="external nofollow noreferrer">Android Launcher分析和修改3&mdash;&mdash;Launcher启动和初始化</a></h2>
<p><strong>Edited by mythou</strong></p>
<p><strong>原创博文，转载请标明出处：<a href="http://www.cnblogs.com/mythou/p/3165259.html" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/p/3165259.html</a>&nbsp;</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn1g2x8.html">&lbrack;LeetCode&rsqb; Random Pick Index 随机拾取序列</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy2x3x9.html">NYOJ题目28大数阶乘</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd51zv9.html">基于AgileEAS&period;NET SOA 平台SAAS架构技术的开源分销ERP系统-SmartERP&period;NET下载配置说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7govxq.html">利用Ajax&plus;MSMQ&lpar;消息队列&rpar;&plus;WebService实现服务器端向客户端的信息推送</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z7l0v9.html">node 的express 如何接受以一个网站的url作为参数的路由</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw7gdr8.html">saltstack之&lpar;五&rpar;数据系统Grains和Pillar</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1oyjx9.html">LepideMigrator for Documents Step by Step</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wrrlvq.html">php中禁止非法调用和硬路径引入文件的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj5ojg8.html">String&comma; StringBuilder&comma; StringBuffer问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjr4738.html">html学习笔记 - table表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxyovq.html">未能解析此远程名称&colon; &amp;&num;39&semi;www&period;&ast;&ast;&ast;&period;com&amp;&num;39&semi; 解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo761xq.html">Docker 网络</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgrk0e8.html">JAVAEE&mdash;&mdash;BOS物流项目12：角色、用户管理，使用ehcache缓存，系统菜单根据登录人展示</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj5lxr9.html">STL用法大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4lgm1q.html">并行Linq</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k6o73q.html">经典面试题：js继承方式上</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1rmzk9.html">SQL datediff&lpar;&rpar;函数 时间差</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj71nvq.html">lintcode-415-有效回文串</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xww3w9.html">APUE学习笔记&mdash;&mdash;10&period;可靠信号与不可靠信号</a>
		</li>
						<li><a href="https://www.batexi.com/a/q154zd59.html">pg limit限制返回的行</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnv6nv28.html">Nmap的详细使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw15pj9.html">【Ray Tracing The Next Week 超详解】 光线追踪2-7 任意长方体 &amp;amp&semi;&amp;amp&semi; 场景案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2pd1j9.html">区域生长算法 全局分类 C&plus;&plus; &amp;amp&semi; matlab</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r0jm39.html">pycharm-2018&period;1&period;6永久激活&lpar;本人使用的是centos7&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j16npl9.html">安装Appium-desktop，并连接模拟器！Appium-Python-Client</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wrvwgq.html">tab------左右布局</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlldkzeq.html">python 发送邮件脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw6gy78.html">zookeepercli - Command Line Interface for ZooKeeper</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e46w6m9.html">linux find命令用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj6zr79.html">Android中Local Service最本质的作用是什么？</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
